#!/usr/bin/env python
#########################################################
#              RETicker v. 0.4.4pre
# a programm to display xml-formatted rss/rdf-feeds in
# a one line display
#########################################################
# please read Help.txt for contact information

#########################################################
# This file contains the classes storing and showing    #
# the actual news                                       #
#########################################################
from __future__ import generators
# import findrox; findrox.version(1,9,12)
# it uses a patched version of ROX-Lib2 in rox/
import rox
from rox import g, tasks

from xml.dom import minidom
import xml.sax
import urllib

import os
import time
import gobject

import tool
from Options import *

### old imports: mightbe deleted sometimes ;)
#from rox.options import Option
#import overview	
#import sys
#from rox.Menu import Menu, set_save_name
#import gc
#import re





class show_list(gobject.GObject):
	def __init__(self, Options, box):
		gobject.GObject.__init__(self)
		self.__Options = Options
		self.__box = box
		self.__news = news_(Options, box)
		self.__fd_count = 0
		self.__msg_index = 0
		self.__feed_jmp = 3 # init-wert
		self.__error = ""
		self.__updatetimeout = None
		self.__no_msg_for_ticker = False
		#tasks.Task(self.init_wait_task())
		self.__news.connect("cached_news_read", self.cached_news_read_slave)
		self.__news.connect("refresh_feed_done", self.refresh_feed_done)
		self.__news.connect("date_info_update", self.date_info_update)
		self.feeds = self.__news.feeds
	def date_info_update(self, dummy, feed): self.emit("date_info_update_slave", feed)
	def refresh_feed_done(self, dummy, feed):
		if (self.__no_msg_for_ticker): self.update_ticker()
		self.emit("refresh_feed_done_slave", feed)
	def refresh_feed(self, dummy, feed): self.__news.refresh_feed(feed)
	def export_xml(self): return self.__news.export_xml()
	def stat(self): return self.__news.stat()
	def cached_news_read_slave(self, event):
		self.emit("cached_news_read_slave")
		self.update_ticker()
		tasks.Task(self.__news.refresh_ticker())
	def is_overview_feed(self, feed):
		if feed.get_active() == 1:
			self.__msg_index = 0
			for msg in feed.msg:
				### nur Ticker parallel updaten, wenn im neuen feed neue news sind
				if feed.msg_is_new(msg):
					self.__fd_count = feed.feed_nr
					self.__feed_jmp = 3
					self.update_ticker()
					return True
				if self.__Options.tt_a_fd_wo_news.int_value == 1: return True
		if self.__Options.tt_a_inactive_fd.int_value == 1: return True
		return False
	def no_ov_feed(self):
		for fd in self.__news.feeds:
			if self.is_overview_feed(fd): return False
		return True
	def ov_next_feed(self, feed):
		if not(feed): feed_nr = -1
		else: feed_nr = feed.feed_nr
		while feed_nr < len(self.__news.feeds)-1:
			feed_nr += 1
			if self.is_overview_feed(self.__news.feeds[feed_nr]): return self.__news.feeds[feed_nr]
		if self.no_ov_feed(): return None
		else: return self.ov_next_feed(None)
	def ov_prev_feed(self, feed):
		if not(feed): feed_nr = len(self.__news.feeds)
		else: feed_nr = feed.feed_nr
		while feed_nr <> 0:
			feed_nr -= 1
			if self.is_overview_feed(self.__news.feeds[feed_nr]): return self.__news.feeds[feed_nr]
		if self.no_msg(): return None
		else: return self.ov_prev_feed(None)
	def no_msg(self):
		self.__error = "no messages"
		for fd in self.__news.feeds:
			if fd.get_active() == 1 and len(fd.msg) > 0 and \
				fd.get_shownews() > 0:
				#if self.__Options.news_age.int_value == 0: return False
				self.__error = "only old messages"
				count = 1
				for i in fd.msg:
					if fd.msg_is_new(i): return False
					count += 1
					if count > fd.get_shownews(): break
		return True
	def next_msg(self):
		# sind news da oder ist lokaler Showcount berschritten?
		self.__error = ""
		if self.__feed_jmp == 1:
			self.__msg_index = 0
			if self.__fd_count + 1 < len(self.__news.feeds):
				self.__fd_count = self.__fd_count + 1
				### change this (maybee by signal)
				### tasks.Task(self.main.overview.akt_feed())
			else:
				if self.no_msg(): return None
				self.__fd_count = 0
			self.emit("next_feed_in_showlist", self.akt_feed())
			#print "SIGNAL: next_feed_in_showlist " + self.__news.feeds[self.__fd_count].get_ticker()
		else:
			if self.__feed_jmp <> 3: self.__msg_index += 1
		self.__feed_jmp = 0
		if self.akt_feed().get_active() == 1:
			while (self.akt_feed().get_shownews() > self.__msg_index) and \
				(len(self.akt_feed().msg) > self.__msg_index):
				if self.akt_msg_is_new(): 
					self.akt_msg().showcount += 1
					return self.akt_msg()
				self.__msg_index += 1
		# check next feed
		self.__feed_jmp = 1
		return self.next_msg()
	def akt_feed(self):
		if self.__news.feeds <> []: return self.__news.feeds[self.__fd_count]
		else: return None
	def akt_msg(self):
		return self.akt_feed().msg[self.__msg_index]
	def akt_msg_is_new(self):
		return self.akt_feed().msg_is_new(self.akt_msg())
	#def init_wait_task(self): #wartet, bis News da sind
	#	while len(self.__news.feeds) == 0:
	#		yield tasks.TimeoutBlocker(2)
	#	self.update_ticker()
	def refresh_update(self, dummy): self.rem_update(); self.add_update()
	def refresh_refresh(self, dummy): self.__news.rem_refresh(); self.__news.add_refresh()
	def start_refresh(self, dummy): self.__news.start_refresh_ticker_task()
	def add_update(self):
		if self.__updatetimeout == None:
			#print "update_timeout added"
			self.__updatetimeout = g.timeout_add(1000*self.__Options.update_time.int_value, self.update_ticker)
	def rem_update(self):
		if self.__updatetimeout <> None:
			#print "update_timeout removed"
			g.timeout_remove(self.__updatetimeout)
			self.__updatetimeout = None
	def update_ticker(self):
		#print "vor update ticker (" + self.__news.stat() + ")"
		#entferne timeout, damit nicht zwei Tasks gleichzeitig updaten
		self.rem_update()
		if self.__Options.v: print "update Ticker"
	       	
		#if self.update_ticker_(): self.news.export_xml() # wird im Moment nur bei autom. Tickerupdate
		self.update_ticker_()
		
		#fge Timeout wieder hinzu
		self.add_update()
		return True
	
	def update_ticker_(self):
		#print "update ticker" + str(len(self.news.feeds)) + self.news.stat()
		i = self.next_msg()
		if not(i):
			self.__no_msg_for_ticker = True
			time_to_wait = self.__news.time_to_next_refresh()
			if time_to_wait == None: message = ", refreshing"
			elif int(time_to_wait) == 0: message = ", waiting " + str(int(time_to_wait*60)) + " seconds"
			else: message = ", waiting " + str(int(time_to_wait)) + " minutes"
			self.__box.label.update(self.__error + message)
			self.__box.label.tooltip.disable()
			self.__box.image.set_from_stock(g.STOCK_CANCEL)
	       		self.__box.image.tooltip.disable()
			return False
		else:
			self.__no_msg_for_ticker = False
			fd = self.__news.feeds[self.__fd_count]
			name = tool.unxml(i.title).encode("utf-8")
			#print name
			self.__box.label.update(name)
			self.__box.image.get_from_file(fd.get_iconcache())
			self.__box.label.addTip(i)
			self.__box.image.addTip(fd, self.__news)
			return True
	def open_page(self):
		self.__box.status_1("opening page in browser", g.STOCK_CONVERT); yield None
		self.akt_msg().read = 1
		if self.__Options.br_options.value <> "":
			os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,\
				self.__Options.browser.value,self.__Options.br_options.value,self.akt_msg().link)
		else: os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,self.__Options.browser.value,self.akt_msg().link)

	def open_page_feed(self):
		self.__box.status_1("opening feed-page in browser", g.STOCK_CONVERT); yield None
		if self.__Options.br_options.value <> "":
			os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,\
				self.__Options.browser.value,self.__Options.br_options.value,self.akt_feed().link)
		else: os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,self.__Options.browser.value,self.akt_feed().link)

gobject.signal_new("cached_news_read_slave", show_list, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	())

gobject.signal_new("next_feed_in_showlist", show_list, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))
		
gobject.signal_new("refresh_feed_done_slave", show_list, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))

gobject.signal_new("date_info_update_slave", show_list, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))

class news_(gobject.GObject):
	def __init__(self, Options, box):
		gobject.GObject.__init__(self)
		self.__Options = Options
		self.__box = box
		#g.Widget.__init__(self)
		self.feeds = []
		self.init_by_sources()
		self.__init = 0 # registriert, ob gecachte Daten gelesen werden
		tasks.Task(self.import_xml())
		self.__refresh_possible = True
		self.__refreshtimeout = None
		self.__lastrefresh = time.time()
		#self.connect("destroy", self.export_xml)
	def init_by_sources(self):
		for source in self.__Options.sources.sources:
			fd = feed(self.__Options, source)
			fd.feed_nr = len(self.feeds)
			source.connect("source_killed", self.kill_feed)
			self.feeds.append(fd)
	def kill_feed(self, dummy, ticker):
		i = 0
		while i < len(self.feeds)-1:
			if ticker == self.feeds[i].get_ticker(): self.feeds.pop(i)
			else: i += 1
	def get_by_ticker(self, ticker):
		for fd in self.feeds:
			if ticker == fd.get_ticker(): return fd
		return None
	"""
	def cmp_feed(self, fd1, fd2):
		if fd1.get_ticker() <> fd2.get_ticker():
			#print "ungleich"
			return False
		if fd1.valid == 1:
			#print "valid"
			return False
		#print "gleich und nicht valid"
		#fd1.valid = 1
		#fd1.active() = fd2.get_active()
		#fd1.get_icon() = fd2.get_icon()
		#fd1.get_iconcache() = fd2.get_iconcache()
		#fd1.get_shownews() = fd2.get_shownews()
		#fd1.get_news_age_by_date() = fd2.get_news_age_by_date()
		return True"""
	def stat(self):
		msg_count = 0
		allmsg_count = 0
		new_count = 0
		act_count = 0
		for fd in self.feeds:
			#print "ticker: " + str(fd.get_ticker())
			if fd.get_active() == 1:
				act_count += 1
				msg_count += len(fd.msg)
				i = 0
				for msg in fd.msg:
					if i < fd.get_shownews():
						if fd.msg_is_new(msg): new_count += 1
						i += 1
					else: continue	
			allmsg_count += len(fd.msg)
		stat =  "feeds: " + str(len(self.feeds)) + "[all]/" + str(act_count) + "[active] msg:" \
				+ str(allmsg_count) + "[all]/"+ str(msg_count) + "[active]/"+ str(new_count) + "[new]"
		return stat
	def export_xml(self):
		from xml.dom.minidom import Document
		doc = Document()
		root = doc.createElement('news')
		doc.appendChild(root)
		for i in self.feeds:
			#print str(i)
			i._to_xml(root)
		#print doc.toxml()
		if not self.__Options.xml_cache.value:
			return	# Saving is disabled
		file = open(self.__Options.xml_cache.value, 'w')
		doc.writexml(file)
		file.close()
		print "Export xml done      (" + self.stat() + ")"
	def import_xml(self):
		if self.__Options.v: print "import cached news ..."
		if not os.path.isfile(self.__Options.xml_cache.value):
			self.__init = 1
			print "No cached news found - initialising"
			self.emit("cached_news_read")
			return
		self.__box.status_1("import cached news ...", g.STOCK_CONVERT)
		yield None
		try:
			doc=minidom.parse(self.__Options.xml_cache.value)
		except xml.sax.SAXParseException:
			self.__box.status_1("parse error in cached news ...", g.STOCK_CANCEL)
			rox.alert("parse error in cached news file:\n" + self.__Options.xml_cache.value)
			yield tasks.TimeoutBlocker(2);
			self.__init = 1
			self.emit("cached_news_read")
			return
		root = doc.documentElement
		assert root.localName == 'news'
		for o in root.childNodes:
			self.read_xml(o, None)
		self.__init = 1 # init done
		if self.__Options.v: print "Cached news imported (" + self.stat() + ")"
		print "Cached news imported (" + self.stat() + ")"
		self.emit("cached_news_read")
		### change this (maybe with signals)
		### self.main.overview.create_window()
	def read_xml(self, xmldoc, ticker):
		#print "read xml: " + xmldoc.toxml()
		channels=xmldoc.getElementsByTagName("channel")
		channel = channels[0]
		
		### ticker - field to recognize the feed - cached data contains ticker
		if not(ticker): ticker = tool.getdata(channel, "ticker") # This is used to recognize the feed
		### additional information
		fd_title = tool.getdata(channel, "title")
		link = tool.getdata(channel, "link")
		desc = tool.getdata_wo_ret(channel, "description")
		### might be overwritten since last access to Options
		active = tool.getdata(channel, "active")	### get this as String to see if available
		#print "active = '" + active + "'"
		provides_date_info = tool.getdata(channel, "provides_date_info")  ### get this as String to see if available
		
		fd = self.get_by_ticker(ticker)
		#print ticker
		#print fd
		if not(fd): return  ### feed not found in sources
		fd.update_info(fd_title, link, desc, active, provides_date_info)

		items=xmldoc.getElementsByTagName("item")
		#yield None
		fd.reinit()
		date_info = 0
		site_count = 0
		for i in items:
			self.__box.status("Checking " + fd_title + " (" + str(site_count) + ")");
			#yield None
			title = tool.getdata(i, "title")
			# manchmal ist der Ticker nicht geupdated, dann msg bergehen
			if title == "": print "kein Titel"; continue
			#print "create message : " + title[:10]
			link = tool.getdata(i, "link")
			desc = tool.getdata_wo_ret(i, "description")
			if desc == "": desc="(keine weitere Info)"
			if self.__init == 0:
				time_ = tool.getfloatdata(i, "time")
				fetchtime = tool.getfloatdata(i, "fetchtime")
			else:
				time_ = tool.gettimedata(i, "dc:date")
				if time_ <> 0: date_info = 1
				fetchtime = time.time()
			showcount = tool.getintdata(i, "showcount")
			read =  tool.getintdata(i, "read")
			tmp_msg = message(title, link, desc, time_, fetchtime, showcount, read)
			fd.add_msg(tmp_msg)
			#print str(fd_title) + " enthlt " + str(len(fd.msg)+1) + " Messages"
			site_count += 1
		if fd.update_date_info(date_info): self.emit("date_info_update", fd)
		fd.pop_cache()
		#self.wait.trigger()
		"""
	def add_feed(self,fd_new):
		#print len(self.feeds)
		for fd_indx in range(0, len(self.feeds)):
			# prfe, ob feed schon vorhanden
			if self.cmp_feed(self.feeds[fd_indx], fd_new):
				if self.__Options.v: print "add_feed: feed_found"
				fd_new.feed_nr = fd_indx; return
		#print "anhngen" 
		fd_new.feed_nr = len(self.feeds)
		self.feeds.append(fd_new)
		if self.__Options.v: print "add_feed: feed_added"
	def take_sources(self):
		sources = self.__Options.sources
		sources.set_valid()
		for i in range(0, len(self.feeds)-1):
			while i < len(self.feeds) and not(self.feeds[i].reinit_by_source()):
				print "kill feed cause not found in Sources: " + self.feeds[i].get_ticker()
				self.feeds.pop(i)
		for source in sources.sources:
			if not(self.get_by_ticker(source.get_ticker())):
				fd = feed(self.__Options, source)
				self.feeds.append(fd)
		for i in range(0, len(self.feeds)-1): self.feeds[i].feed_nr = i
		"""
	def time_to_next_refresh(self):
		if self.__refreshtimeout <> None:
			return self.__Options.refresh_time.int_value - \
				(time.time() - self.__lastrefresh)/60
		else: return None
	def add_refresh(self):
		if self.__refreshtimeout == None:
			#print "refresh_timeout added"
			self.__refreshtimeout = g.timeout_add(60000*self.__Options.refresh_time.int_value, self.start_refresh_ticker_task)
	def rem_refresh(self):
		if self.__refreshtimeout <> None:
			#print "refresh_timeout removed"
			g.timeout_remove(self.__refreshtimeout);
			self.__refreshtimeout = None
	def start_refresh_ticker_task(self):
		tasks.Task(self.refresh_ticker())
	def refresh_ticker(self):
		if self.__refresh_possible:
			self.__refresh_possible = False
		else:
			if self.__Options.v: print "refresh Ticker blocked"
			return
		self.rem_refresh()
		if self.__Options.v: print "refresh Ticker"
		self.__lastrefresh = time.time()
		#self.take_sources() ### change this maybe onl on special times
		if self.__Options.v: print "found " + str(len(self.feeds)) + " sources"
		for i in self.feeds:
			if i.get_active() <> 1: continue
			if not(os.path.isfile(i.get_iconcache())):
				print i.get_icon()
				print i.get_iconcache()
				icon = i.get_icon()
				iconcache = i.get_iconcache()
				if self.__Options.v: print "Getting Icon from " + icon
				self.__box.status_1("Getting Icon from " + icon, g.STOCK_JUMP_TO)
				yield None
				try:
					urllib.urlretrieve(icon,iconcache)
				except (IOError, EOFError):
					iconcache = rox.app_dir+"/AppIcon.xpm"
					self.__box.status_1("Icon at " + icon + " not retrieved",g.STOCK_CANCEL)
					yield tasks.TimeoutBlocker(2)
		tasks.Task(self.check_feed())
	
	def check_feed(self):		
		for fd in self.feeds:
			if self.__Options.v: print str(fd)
			if fd.get_active() == 1:
				self.__box.status_2("Checking " + fd.get_ticker() + " ...",fd.get_iconcache(), g.STOCK_CONVERT)
				yield None
				try:
					feed=urllib.urlopen(fd.get_ticker())
				except (IOError, EOFError):
					print "could not open url " + fd.get_ticker()
					self.__box.status_2("Checking " + fd.get_ticker() + " ...",fd.get_iconcache(), g.STOCK_CANCEL)
					yield tasks.TimeoutBlocker(2);
					continue
				try:
					xmldoc=minidom.parse(feed)
				except xml.sax.SAXParseException:
					self.__box.status_2("Checking " + fd.get_ticker() + " ...",fd.get_iconcache(), g.STOCK_CANCEL)
					yield tasks.TimeoutBlocker(2);
					continue
				yield None
				self.read_xml(xmldoc, fd.get_ticker())
				self.emit("refresh_feed_done", fd)
		print "Refresh done         (" + self.stat() +")"
		self.export_xml()
		self.__refresh_possible = True
		self.add_refresh()
	def refresh_feed(self, fd):
		self.__box.status_2("Checking " + fd.get_ticker() + " ...",fd.get_iconcache(), g.STOCK_CONVERT)
		try:
			feed=urllib.urlopen(fd.get_ticker())
		except (IOError, EOFError):
			rox.alert("could not open url : " + fd.get_ticker())
			self.__box.status_2("Checking " + fd.get_ticker() + " ...",fd.get_iconcache(), g.STOCK_CANCEL)
			return
		try:
			xmldoc=minidom.parse(feed)
		except xml.sax.SAXParseException:
			rox.alert("error in parsing feed from : " + fd.get_ticker())
			self.__box.status_2("Checking " + fd.get_ticker() + " ...",fd.get_iconcache(), g.STOCK_CANCEL)
			return
		self.read_xml(xmldoc, fd.get_ticker())
		self.emit("refresh_feed_done", fd)
	

gobject.signal_new("refresh_feed_done", news_, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))

gobject.signal_new("cached_news_read", news_, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	())

gobject.signal_new("date_info_update", news_, \
	gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, \
	(gobject.TYPE_PYOBJECT,))
		
### class for a news message and all information related to one
class message:
	def __init__(self, title, link, desc, time, fetchtime, showcount, read):
		self.title = title
		self.link  = link
		self.desc  = desc
		self.time  = time		# time wich found in field dc:date
		self.fetchtime = fetchtime	# time when message was fetched
		self.showcount = showcount	# how often message was shown in ticker
		self.read = read		# if 1, message was opened in browser
	### export contents of message to xml
	def _to_xml(self, parent):
		def createNode(doc, name, data):
			node = doc.createElement(name)
			node.appendChild(doc.createTextNode(data))
			return node
		doc = parent.ownerDocument
		root = doc.createElement('item')
		parent.appendChild(root)
		root.appendChild(createNode(doc, 'title', self.title))
		root.appendChild(createNode(doc, 'link', self.link))
		root.appendChild(createNode(doc, 'description', self.desc))
		root.appendChild(createNode(doc, 'time', str(self.time)))
		root.appendChild(createNode(doc, 'fetchtime', str(self.fetchtime)))
		root.appendChild(createNode(doc, 'showcount', str(self.showcount)))
		root.appendChild(createNode(doc, 'read', str(self.read)))
		return doc
				
### class for a news feed -- contains a list of messages 
import Options
class feed:
	def __init__(self, myOptions, source):
		self.__Options = myOptions
		self.__source = source
		### additional data-fields with basic information
		#self.__active = source.get_active()
		self.ticker = self.__source.ticker ## use source Ticker only as label...
		self.title = None
		self.link = None
		self.desc = None
		self.msg = []			# stores the messages
		### additional fields
		self.feed_nr = None		# number in parent news feed-list
		self.__add_pos = 0		# pos to add next msg
		self.__cache_count = 0		# max number of msg to cache
		self.__tmp_cache_count = 0
	def get_active(self): return self.__Options.sources.get_active_by_ticker(self.ticker)
	def get_ticker(self):
		if self.ticker.find("://") == -1: return "http://" + self.ticker
		else: return self.ticker
	def get_icon(self):
		icon = self.__Options.sources.get_icon_by_ticker(self.ticker)
		if icon == "":
			pos = self.ticker[8:].find("/")
			if pos <> -1: pos = pos + 8
			if pos <> -1: icon =  self.ticker[:pos] + "/favicon.ico"
			else:	icon =  self.ticker + "/favicon.ico"
		else:
			if icon.find("://") == -1: icon = "http://" + icon
		return icon
	def get_iconcache(self):
		iconcache = self.__Options.sources.get_iconcache_by_ticker(self.ticker)
		if iconcache == "":
			iconcache = tool.tmp_name(self.__Options.icon_cache_dir.value, self.get_icon())
		return iconcache
	def get_shownews(self): return self.__Options.sources.get_shownews_by_ticker(self.ticker)
	def get_news_age_by_date(self): return self.__Options.sources.get_news_age_by_date_by_ticker(self.ticker)
	def get_provides_date_info(self): return self.__Options.sources.get_provides_date_info_by_ticker(self.ticker)
	### export contents of feed and all messages to xml
	"""
	def reinit_by_source(self):
		source = self.__Options.sources.get_by_ticker(self.ticker)
		if not(source): return False
		self.active = source.active
		self.ticker = source.ticker
		self.__icon = source.icon
		self.__iconcache = source.iconcache
		self.set_real_values()
		self.shownews = source.shownews
		self.news_age_by_date = source.news_age_by_date
		self.provides_date_info = source.provides_date_info
		return True	"""	
	def update_info(self, title, link, \
		desc, active, provides_date_info):
		self.title = title
		self.link = link
		self.desc = desc
		#if active <> "": self.active = int(active)
		#print "update_info"
	def update_date_info(self, provides_date_info):
		#print provides_date_info
		#print self.get_provides_date_info()
		if self.get_provides_date_info() <> provides_date_info:
			self.provides_date_info = provides_date_info
			#print "date_info_update"
			return True
		return False
	def _to_xml(self, parent):
		def createNode(doc, name, data):
			node = doc.createElement(name)
			if data == None: data = ""
			node.appendChild(doc.createTextNode(data))
			return node
		doc = parent.ownerDocument
		root = doc.createElement('feed')
		parent.appendChild(root)
		root_c = doc.createElement('channel')
		root.appendChild(root_c)
		root_c.appendChild(createNode(doc, 'title', self.title))
		#root_c.appendChild(createNode(doc, 'active', str(self.active)))
		root_c.appendChild(createNode(doc, 'ticker', self.ticker))
		#root_c.appendChild(createNode(doc, 'icon', self.__icon))
		#root_c.appendChild(createNode(doc, 'iconcache', self.__iconcache))
		#root_c.appendChild(createNode(doc, 'shownews', str(self.shownews)))
		#root_c.appendChild(createNode(doc, 'news_age_by_date', str(self.news_age_by_date)))
		root_c.appendChild(createNode(doc, 'link', self.link))
		root_c.appendChild(createNode(doc, 'description', self.desc))
		for i in self.msg:
			i._to_xml(root)
		return doc		
	### if number of messages from server increases, inc cache_count
	### remove last msg as long as to many msg stored
	def pop_cache(self):
		if self.__cache_count < self.__tmp_cache_count:
			self.__cache_count = self.__tmp_cache_count
		while len(self.msg) > self.__cache_count:
			print "message deleted"
			self.msg.pop()
	### bevor refreshing this feed, reset some counters
	def reinit(self): self.__add_pos = 0; self.__tmp_cache_count = 0
	### say if two messages are equal (here same title and same link)
	def cmp_msg(self, msg1, msg2):
		#print "c: " + msg1.title[:10] + " vs " + msg2.title[:10]
		if msg1.title <> msg2.title: return False	
		if msg1.link <> msg2.link: return False
		return True
	### adds message, if it is a new message
	def add_msg(self,msg_new):
		#print "add msg (bisher " + str(len(self.msg)) + ")"
		self.__tmp_cache_count += 1
		for msg_old in self.msg:
			# try, if message still in feed
			if self.cmp_msg(msg_old, msg_new): return
		if msg_new.time <> 0: # feed-msg provides dc:date info, so use it
				      # to find right position for new msg
			self.date_info = 1 # indicate dc:date info
			#search timeposition
			for index in range(0, len(self.msg)-1):
				index_time = self.msg[index].time
				if index_time == 0: index_time = self.msg[index].fetchtime
				if index_time < msg_new.time:
					self.msg.insert(index, msg_new)
					if index < self.__add_pos: self.__add_pos += 1
					return
			self.msg.append(msg_new)	#not found
		else:
			# if no cd_timestamp provided, add at first position
			self.msg.insert(self.__add_pos, msg_new)
			self.__add_pos += 1
	### check, if message is new in terms of user wishes
	def msg_is_new(self, msg):
		# check if message was read in browser
		if msg.read == 1: return False
		# check if msg-fetchtimestamp is to old
		if self.__Options.news_age.int_value <> 0 and \
			msg.fetchtime + self.__Options.news_age.int_value*60 < time.time():
			return False
		# check if msg-timestamp is to old
		if self.get_news_age_by_date() <> 0 and self.get_provides_date_info() == 1 and \
			msg.time + self.get_news_age_by_date() * 60 < time.time():
			return False
		# check if msg-showcount is less then max showcount
		if self.__Options.news_showcount.int_value <> 0 and \
			msg.showcount >= self.__Options.news_showcount.int_value:
			return False
		return True
	
