#!/usr/bin/env python
from __future__ import generators
# import findrox; findrox.version(1,9,12)
# it uses a patched version of ROX-Lib2 in rox/
import rox
from rox import g, tasks
from Options import *
import RETicker
import tool
import ticker_menu
import time

class StatusLine(g.HBox):
	def __init__(self, Options, overview = None):
		self.__overview = overview
		self.__Options = Options
		g.HBox.__init__(self)
		self.__feed = None
		self.__i_act = tool.EventImage(g.STOCK_NO, lambda x,y: self.emit("switch_active", self.__feed), "inactive (click to change)")
		self.__i_act.set_small()
		self.pack_start(self.__i_act, g.FALSE, g.FALSE, 1)

		self.__i_ref = tool.EventImage(g.STOCK_REFRESH, lambda x,y: self.emit("refresh_feed", self.__feed), "refresh this source")
		self.__i_ref.set_small()
		self.pack_start(self.__i_ref, g.FALSE, g.FALSE, 1)
		
		self.__label=g.Label()
		self.__label.set_size_request(-1,-1)
		self.__label.set_alignment(0,0)
		self.__label.set_padding(3,0)
		self.__label.show()
		self.add(self.__label)
		self.sig_switch_active = None
		self.refresh_colors()
		self.show
		self.__Options.connect("refresh_ov_colors", self.refresh_colors)
	def refresh_colors(self, dummy = None):
		if self.__overview: bg_color = self.__Options.ov_bg_stat.value; fg_color = self.__Options.ov_color_old_msg.value
		else: bg_color = self.__Options.tt_a_bg_stat.value; fg_color = self.__Options.tt_a_color_old_msg.value
		self.__i_act.modify_bg(g.STATE_NORMAL,self.__i_act.get_colormap().alloc_color(bg_color))
		self.__i_ref.modify_bg(g.STATE_NORMAL,self.__i_ref.get_colormap().alloc_color(bg_color))
		self.__label.modify_fg(g.STATE_NORMAL,self.__label.get_colormap().alloc_color(fg_color))
	def reinit(self, feed):
		if self.sig_switch_active: self.__Options.sources.get_by_ticker(self.__feed.ticker).disconnect(self.sig_switch_active)
		self.__feed = feed
		self.sig_switch_active = self.__Options.sources.get_by_ticker(self.__feed.ticker).connect("change_active", self.reset_active)
		if self.__feed:
			text = self.__feed.title
			if not(text) or text == "": text = self.__feed.ticker
			if self.__feed.get_active() == 1:
				self.__i_act.set_from_stock(g.STOCK_YES); self.__i_act.set_tip("active (click to change)")
			else:
				self.__i_act.set_from_stock(g.STOCK_NO); self.__i_act.set_tip("inactive (click to change)")
		else: text = "no messages to show"; self.__i_act = tool.EventImage(g.STOCK_MISSING_IMAGE, None, None)
		self.__label.set_text(text)
		self.__i_act.set_small()
	def reset_active(self, dummy):
		if self.__feed:
			if self.__feed.get_active() == 1:
				self.__i_act.set_from_stock(g.STOCK_YES); self.__i_act.set_tip("active (click to change)")
			else:
				self.__i_act.set_from_stock(g.STOCK_NO); self.__i_act.set_tip("inactive (click to change)")
		else: self.__i_act = tool.EventImage(g.STOCK_MISSING_IMAGE, None, None)
		self.__i_act.set_small()
		
		#self.__i_act.modify_bg(g.STATE_NORMAL,self.__i_act.get_colormap().alloc_color('#eee2b4'))
gobject.signal_new("switch_active", StatusLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,))
gobject.signal_new("refresh_feed", StatusLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,))
	
		

class NavLine(g.HBox):
	def __init__(self, Options, overview = None):
		self.__Options = Options
		self.__overview = overview
		g.HBox.__init__(self)
		self.i_prev = tool.EventImage(g.STOCK_GO_BACK, lambda x,y: self.emit("prev_feed"), "previous feed")
		self.i_next = tool.EventImage(g.STOCK_GO_FORWARD, lambda x,y: self.emit("next_feed"), "next feed")
		self.__i_icon = tool.EventImage(g.STOCK_MISSING_IMAGE, lambda x,y: self.emit("open_feed_page"), None)
		self.pack_start(self.i_prev, g.FALSE, g.FALSE, 0)
		self.pack_start(self.__i_icon, g.FALSE, g.FALSE, 0)
		self.pack_start(self.i_next, g.FALSE, g.FALSE, 0)
		self.i_refresh = tool.EventImage(g.STOCK_REFRESH, lambda x,y: self.emit("refresh_all"), "refresh news")
		self.pack_start(self.i_refresh, g.FALSE, g.FALSE, 10)
		
		self.i_options = tool.EventImage(g.STOCK_PREFERENCES, lambda x,y: self.emit("open_options"), "Preferences")
		self.i_window = tool.EventImage(g.STOCK_INDEX, lambda x,y: self.emit("open_overview_window"), "Overview")
		self.i_help = tool.EventImage(g.STOCK_HELP, lambda x,y: self.emit("help"), "Help")
		self.__i_info = tool.EventImage(g.STOCK_DIALOG_INFO, lambda x,y: self.emit("info"), None)
		self.i_quit = tool.EventImage(g.STOCK_QUIT, lambda x,y: self.emit("quit"), "Exit NewsTicker")
		
		self.pack_end(self.i_quit, g.FALSE, g.FALSE, )
		self.pack_end(self.i_help, g.FALSE, g.FALSE, 0)
		self.pack_end(self.__i_info, g.FALSE, g.FALSE, 0)
		self.pack_end(self.i_options, g.FALSE, g.FALSE, 5)
		self.pack_end(self.i_window, g.FALSE, g.FALSE, 5)
		self.refresh_colors()
		self.show()
		self.__Options.connect("refresh_ov_colors", self.refresh_colors)
	def refresh_colors(self, dummy = None):
		if self.__overview: bg_color = self.__Options.ov_bg_stat.value
		else: bg_color = self.__Options.tt_a_bg_stat.value
		self.i_prev.modify_bg(g.STATE_NORMAL,self.i_prev.get_colormap().alloc_color(bg_color))
		self.__i_icon.modify_bg(g.STATE_NORMAL,self.__i_icon.get_colormap().alloc_color(bg_color))
		self.i_next.modify_bg(g.STATE_NORMAL,self.i_next.get_colormap().alloc_color(bg_color))
		self.i_refresh.modify_bg(g.STATE_NORMAL,self.i_refresh.get_colormap().alloc_color(bg_color))
		self.i_options.modify_bg(g.STATE_NORMAL,self.i_options.get_colormap().alloc_color(bg_color))
		self.i_help.modify_bg(g.STATE_NORMAL,self.i_help.get_colormap().alloc_color(bg_color))
		self.__i_info.modify_bg(g.STATE_NORMAL,self.__i_info.get_colormap().alloc_color(bg_color))
		self.i_quit.modify_bg(g.STATE_NORMAL,self.i_quit.get_colormap().alloc_color(bg_color))
		self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color(bg_color))
	def reinit(self, feed, stat):
		self.__i_info.set_tip(stat)
		if feed:
			self.set_icon(feed.get_iconcache())
			if feed.title: title = tool.unxml(feed.title).encode("utf-8")
			else: title = ""
			if feed.desc: desc = tool.unxml(feed.desc).encode("utf-8")
			else: desc = ""
			if title <> "": tip = title
			else: tip = ""
			if desc <> "":
				if tip <> "": tip += "\n"
				tip += desc
			if tip == "": tip = "No Information about feed available,\nyou have to refresh this feed."
			self.set_tip(tip)
		else:
			self.set_icon(None)
		
	def set_icon(self, Filename):
		if Filename == None: self.__i_icon.hide()
		else: self.__i_icon.show(); self.__i_icon.get_from_file(Filename)
	def set_tip(self, Tip):
		self.__i_icon.set_tip(Tip)
	def set_stat(self, stat):
		self.__i_info.set_tip(stat)

gobject.signal_new("next_feed", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("prev_feed", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("open_feed_page", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("refresh_all", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("open_options", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("open_overview_window", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("help", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("info", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())
gobject.signal_new("quit", NavLine, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, ())

class ov_message(g.EventBox):
	def __init__(self, Options, feed, msg, count, overview = None):
		self.__Options = Options
		self.__feed = feed
		self.__overview = overview ## to recognize the different color used by window
		self.__msg = msg
		self.__count = count
		g.EventBox.__init__(self)
		text = tool.unxml(self.__msg.title).encode("utf-8")
		
		self.__tooltip = g.Tooltips()
		self.__tooltip.enable()
		if self.__Options.show_age.int_value == 1:
			page_time = msg.fetchtime
			time_val = time.strftime("%a %H:%M", time.localtime(page_time))
			if msg.time <> 0:	page_time = msg.time; time_val += time.strftime(" [%a %H:%M]", time.localtime(page_time))
		if self.__Options.show_stat.int_value == 1:
			stat = "[" + str(msg.showcount) + "x]"

		tiptext = text + " (" + time_val + " " + stat +")"
		
		if self.__overview: text = time_val + " " + stat + " " + text
		
		desc = tool.unxml(msg.desc.encode("utf-8"))
		if desc <> "(keine weitere Info)":
			tiptext += "\n---------------------\n" + desc
		self.__tooltip.set_tip(self, tiptext)
		
		self.__label=g.Label(text)
		self.__label.set_size_request(-1,-1)
		self.__label.set_alignment(0,0)
		self.__label.set_padding(3,0)
		self.__label.show()
		self.add(self.__label)
		self.show()
		self.set_events(g.gdk.ENTER_NOTIFY_MASK | g.gdk.LEAVE_NOTIFY_MASK)
		self.connect("enter-notify-event", self.enter_widget)
		self.connect("leave-notify-event", self.leave_widget)
		self.connect("button_press_event",self.callback_event)

		self.refresh_colors()
		self.__Options.sources.get_by_ticker(self.__feed.ticker).connect("change_active", self.refresh_colors)
		self.__Options.connect("refresh_ov_colors", self.refresh_colors)
	def refresh_colors(self, dummy = None):
		#print "refresh_color ov_message"
		if self.__feed.get_active() == 1:
			if self.__overview: bg_color = self.__Options.ov_bg.value
			else: bg_color = self.__Options.tt_a_bg.value
		else:
			if self.__overview: bg_color = self.__Options.ov_bg_inactive.value
			else: bg_color = self.__Options.tt_a_bg_inactive.value
		if self.__overview: fg_color = self.__Options.ov_color_old_msg.value
		else: fg_color = self.__Options.tt_a_color_old_msg.value
		if self.__feed.msg_is_new(self.__msg):
			if self.__overview: fg_color = self.__Options.ov_color_new_msg.value
			else: fg_color = self.__Options.tt_a_color_new_msg.value
		if self.__count > self.__feed.get_shownews():
			if self.__overview: fg_color = self.__Options.ov_color_not_shown_msg.value
			else: fg_color = self.__Options.tt_a_color_not_shown_msg.value
		self.__label.modify_fg(g.STATE_NORMAL,self.__label.get_colormap().alloc_color(fg_color))
		self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color(bg_color))
		
	def enter_widget(self, widget, event):
		widget.set_state (g.STATE_PRELIGHT)
	def leave_widget(self, widget, event):
		widget.set_state (g.STATE_NORMAL)
	def callback_event(self, widget, event):
		widget.set_state (g.STATE_SELECTED)
		if event.button == 1: tasks.Task(self.open_page())
        	### change this
		###if event.button == 2: self.main.show_list.update_ticker_()
		###if event.button == 3: self.__parent.open_menu(widget, event, None, self.__msg)
	def open_desc_window(self):
		yield None
		desc_window = Desc_Window(self.__msg, self.__label)
	def open_page(self):
        	yield None
		if self.__overview: fg_color = self.__Options.ov_color_old_msg.value
		else: fg_color = self.__Options.tt_a_color_old_msg.value
		self.modify_fg(g.STATE_NORMAL,self.get_colormap().alloc_color(fg_color))
		self.__msg.read = 1
		yield None
		if self.__Options.br_options.value <> "":
			os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,\
				self.__Options.browser.value,self.__Options.br_options.value,self.__msg.link)
		else: os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,self.__Options.browser.value,self.__msg.link)

class ov_feed(g.EventBox):
	def __init__(self, Options, overview = None):
		self.__Options = Options
		self.__feed = None
		self.__overview = overview ## to recognize the different color used by window
		self.sig_active = None
		########################
		g.EventBox.__init__(self)
		self.vbox = None
		self.__Options.connect("refresh_ov_colors", self.refresh_colors)
		self.label1 = None
		self.label2 = None
	def refresh_colors(self, dummy = None):
		#print "refresh_color ov_feed"
		if self.__feed.get_active() == 1:
			if self.__overview: bg_color = self.__Options.ov_bg.value
			else: bg_color = self.__Options.tt_a_bg.value
		else:
			if self.__overview: bg_color = self.__Options.ov_bg_inactive.value
			else: bg_color = self.__Options.tt_a_bg_inactive.value
		self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color(bg_color))
		if self.__overview: fg_color = self.__Options.ov_color_old_msg.value
		else: fg_color = self.__Options.tt_a_color_old_msg.value
		if self.label1:
			self.label1.modify_fg(g.STATE_NORMAL,self.label1.get_colormap().alloc_color(fg_color))
		if self.label2:
			self.label2.modify_fg(g.STATE_NORMAL,self.label2.get_colormap().alloc_color(fg_color))
	def reinit(self, fd):
		if self.vbox: self.remove(self.vbox); del self.vbox; self.vbox = None
		if self.sig_active and self.__Options.sources.get_by_ticker(self.__feed.ticker):
			self.__Options.sources.get_by_ticker(self.__feed.ticker).disconnect(self.sig_active)
		self.sig_active = None
		count = 1
		#fd = None for testing
		if fd:
			self.vbox = g.VBox()
			self.add(self.vbox)
			self.__feed = fd
			#print str(self.__feed)
			self.sig_active = self.__Options.sources.get_by_ticker(self.__feed.ticker).connect("change_active", self.refresh_colors)
			if len(self.__feed.msg) <> 0:
				for i in self.__feed.msg:
					self.vbox.pack_start(ov_message(self.__Options, self.__feed, i, count, self.__overview), g.FALSE, g.FALSE, 0)
					count += 1
				self.label1 = None
				self.label2 = None
			else:
				self.label1=g.Label("no messages available")
				self.label1.set_size_request(-1,-1)
				self.label1.set_alignment(0,0)
				self.label1.set_padding(3,0)
				self.label1.show()
				self.label2=g.Label("maybe you have to\nactivate ticker or\nrefresh the news")
				self.label2.set_size_request(-1,-1)
				self.label2.set_alignment(0,0)
				self.label2.set_padding(3,0)
				self.label2.show()
				self.vbox.pack_start(self.label1, g.FALSE, g.FALSE, 0)
				self.vbox.add(self.label2)
			self.refresh_colors()
			self.show_all()


class overview(gobject.GObject):
	def __init__(self, Options, show_list):
		self.__Options = Options
		self.__show_list = show_list
		######################
		gobject.GObject.__init__(self)
		self.win = None
	def destroy(self):
		print "destroy it"
	def change_size(self, dummy, event):
		width, height = self.win.get_size()
		if width <> self.__Options.ov_hor_size.int_value or height <> self.__Options.ov_ver_size.int_value:
			self.emit("size_changed_ov", width, height)
	def refresh_size(self, dummy=None):
		#self.set_size_request(self.__Options.ov_hor_size.int_value,self.__Options.ov_ver_size.int_value)
		self.win.resize(self.__Options.ov_hor_size.int_value,self.__Options.ov_ver_size.int_value)
	def refresh_colors(self, dummy=None):
		self.viewport.modify_bg(g.STATE_NORMAL,self.viewport.get_colormap().alloc_color(self.__Options.ov_bg_stat.value))
		self.win.modify_bg(g.STATE_NORMAL,self.win.get_colormap().alloc_color(self.__Options.ov_bg.value))		
	def switch_feed_active(self, dummy, feed):
		self.emit("switch_active_slave", feed)
		#self.reinit()
	def refresh_feed(self, dummy, feed):
		self.emit("refresh_feed_slave", feed)
		self.reinit()
	def reinit(self):
		self.viewport.remove(self.vbox_in)
		del self.vbox_in
		self.vbox_in = g.VBox()
		self.viewport.add(self.vbox_in)
		self.show_now()		
	def recreate_window(self, dummy = None):
		if self.win: self.win.present(); return
		self.win = g.Window()
		self.vbox = g.VBox()
		self.swin=g.ScrolledWindow()
		self.swin.set_shadow_type(g.SHADOW_NONE)
		self.swin.set_policy(g.POLICY_AUTOMATIC, g.POLICY_AUTOMATIC)
		self.win.add(self.vbox)
		self.vbox_in = g.VBox()
		self.viewport = g.Viewport()
		self.viewport.add(self.vbox_in)
		self.viewport.set_shadow_type(g.SHADOW_NONE)
		self.swin.add(self.viewport)
		self.vbox.add(self.swin)
		self.win.set_size_request(50,40)
		self.refresh_size()
		self.refresh_colors()
		self.__Options.connect("refresh_ov_colors", self.refresh_colors)
		self.__Options.connect("refresh_ov_size", self.refresh_size)
		self.win.set_events(g.gdk.CONFIGURE)
		self.win.connect('configure-event',self.change_size)
		self.show_now()
	def show_now(self):
		for feed in self.__show_list.feeds:
			#source = self.__Options.sources.get_by_ticker(feed.get_ticker())
			#source.connect("source_killed", self.kill_feed, feed)
			sep = g.HSeparator()
			stat = StatusLine(self.__Options, True)
			stat.reinit(feed)
			stat.connect("switch_active", self.switch_feed_active)
			stat.connect("refresh_feed", self.refresh_feed)
			overview = ov_feed(self.__Options, True)
			overview.reinit(feed)
			self.vbox_in.pack_start(sep, g.FALSE, g.FALSE, 0)
			self.vbox_in.pack_start(stat, g.FALSE, g.FALSE, 0)
			self.vbox_in.pack_start(overview, g.FALSE, g.FALSE, 0)
		#self.__overview.stat.connect("switch_active", self.__Options.sources_switch_feed_active)
		#self.__overview.stat.connect("refresh_feed", self.__show_list.refresh_feed)
		#self.set_events(g.gdk.ENTER_NOTIFY_MASK | g.gdk.LEAVE_NOTIFY_MASK)
		#self.connect("enter-notify-event", self.enter_widget)
		#self.connect("leave-notify-event", self.leave_widget)
		#self.connect("button-press-event", self.button_pressed)
		#self.Menu = None

		#self.nav.connect("next_feed", self.next_feed)
		#self.nav.connect("prev_feed", self.prev_feed)
		#self.nav.connect("open_feed_page", self.open_feed)
		#self.sig_kill_feed = None
		#self.set_decorated(g.FALSE)
		self.win.show_all()
gobject.signal_new("switch_active_slave", overview, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,))
gobject.signal_new("refresh_feed_slave", overview, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,))
gobject.signal_new("size_changed_ov", overview, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,gobject.TYPE_PYOBJECT,))

class ov_aktfeed(g.Window):
	def __init__(self, Options, show_list):
		self.__Options = Options
		self.__show_list = show_list
		self.__initialized = False     	### window is created (after getting some news)
		self.__active = False		### Mouse is or was over window
		self.__tip = False		### shown as tip
		self.__menu = False		### shown as menu
		self.__feed = None
		######################
		g.Window.__init__(self)
		
		self.new_frame=g.Frame()
		self.ebox = g.EventBox() # without thisone the enter and leave-widget events dont work
		vbox = g.VBox()
		self.swin=g.ScrolledWindow()
		self.swin.set_shadow_type(g.SHADOW_NONE)
		
		
		self.viewport = g.Viewport()
		self.viewport.set_shadow_type(g.SHADOW_NONE)
		self.viewport.set_border_width(2)
		self.swin.add(self.viewport)

		self.__overview = ov_feed(self.__Options)
		self.stat = StatusLine(self.__Options)
		self.nav = NavLine(self.__Options)
		vbox.pack_start(self.stat, g.FALSE, g.FALSE, 0)
		vbox.pack_end(self.nav, g.FALSE, g.FALSE, 0)
		
		vbox.add(self.swin)
		self.new_frame.add(vbox)
		self.ebox.add(self.new_frame)
		
		self.add(self.ebox)
		#self.modify_bg(g.STATE_NORMAL,self.get_colormap().alloc_color('black'))
		self.set_size_request(self.__Options.tt_a_hor_size.int_value,self.__Options.tt_a_ver_size.int_value)
		self.set_events(g.gdk.CONFIGURE | g.gdk.ENTER_NOTIFY_MASK | g.gdk.LEAVE_NOTIFY_MASK)
		self.connect("enter-notify-event", self.enter_widget)
		self.connect("leave-notify-event", self.leave_widget)
		#self.connect("button-press-event", self.button_pressed)
		self.Menu = None

		self.nav.connect("next_feed", self.next_feed)
		self.nav.connect("prev_feed", self.prev_feed)
		self.nav.connect("open_feed_page", self.open_feed)
		self.sig_kill_feed = None
		self.set_decorated(g.FALSE)
		self.set_scrollbars()
		self.set_size_request(50,40)
		self.refresh_size()
		self.refresh_colors()
		self.__Options.connect("refresh_ov_colors", self.refresh_colors)
		self.__Options.connect("refresh_tt_a_size", self.refresh_size)
		self.connect('configure-event',self.change_size)
	def change_size(self, dummy, event):
		width, height = self.get_size()
		if width <> self.__Options.tt_a_hor_size.int_value or height <> self.__Options.tt_a_ver_size.int_value:
			self.emit("size_changed_tt_a", width, height)
	def refresh_size(self, dummy=None):
		self.resize(self.__Options.tt_a_hor_size.int_value, self.__Options.tt_a_ver_size.int_value)
	def refresh_colors(self, dummy=None):
		self.new_frame.modify_bg(g.STATE_NORMAL,self.new_frame.get_colormap().alloc_color('black'))
		self.ebox.modify_bg(g.STATE_NORMAL,self.ebox.get_colormap().alloc_color(self.__Options.tt_a_bg_stat.value))
	### create window for the first time after news found in cache, set initialized true
	def create_window(self, widget = None):
		if self.sig_kill_feed: source.disconnect(self.sig_kill_feed)
		self.__feed = self.__show_list.akt_feed()
		source = self.__Options.sources.get_by_ticker(self.__feed.get_ticker())
		self.sig_kill_feed = source.connect("source_killed", self.create_window)
		self.viewport.add(self.__overview)
		self.__overview.reinit(self.__feed)
		self.stat.reinit(self.__feed)
		self.nav.reinit(self.__feed, self.__show_list.stat())
		self.__initialized = True
	def set_scrollbars(self, dummy=None):
		if self.__Options.tt_a_hor_scrollbar.int_value == 1: hor_bar = g.POLICY_AUTOMATIC
		else: hor_bar = g.POLICY_NEVER
		if self.__Options.tt_a_ver_scrollbar.int_value == 1: ver_bar = g.POLICY_AUTOMATIC
		else: ver_bar = g.POLICY_NEVER
		self.swin.set_policy(hor_bar, ver_bar)
	def refresh_stat(self):
		self.nav.set_stat(self.__show_list.stat())
	def open_feed(self, widget):
		if self.__feed:
			if self.__Options.br_options.value <> "":
				os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,\
					self.__Options.browser.value,self.__Options.br_options.value,self.__feed.link)
			else: os.spawnlp(os.P_NOWAIT,self.__Options.browser.value,self.__Options.browser.value,self.__feed.link)
	def next_feed(self, widget):
		self.__feed = self.__show_list.ov_next_feed(self.__feed); self.refresh()
	def prev_feed(self, widget):
		self.__feed = self.__show_list.ov_prev_feed(self.__feed); self.refresh()
	def refresh_if_actual(self, dummy, feed):
		if not(self.__feed): return
		if self.__feed.ticker <> feed.ticker: return 
		self.refresh()
	def akt_feed(self, showlist, feed):
		#print "akt_feed" +str(showlist) + str(feed)
		#yield None
		if self.__active: return
		if feed.title == None: return
		self.__feed = feed
		self.refresh()
	### init window contents but dont show them
	def refresh(self):
		#print "ov_aktive refresh " + str(self.__feed)
		self.__overview.reinit(self.__feed)
		self.stat.reinit(self.__feed)
		self.nav.reinit(self.__feed, self.__show_list.stat())
	def button_pressed(self, widget, event):
		print "button pressed"
	def enter_widget(self, widget, event):
		#print "enter wdget"
		self.__active = True
		#widget.set_state (g.STATE_PRELIGHT)
	def leave_widget(self, widget, event):
		#print "leave widget"
		if not(self.__active):
			#print "keine Ahnung wann das passiert"
			return
		else: 
			if not(self.Menu): self.hide_later(None)
		#widget.set_state (g.STATE_NORMAL)
	def get_position(self, tip):
		self.realize()
		if tip: x, y = g.gdk.get_default_root_window().get_position()
		return x, y
	def show_now_as_tip(self, x, y, w, h):
		if self.__Options.tt_a.int_value == 1 \
			and self.__Options.tt_a_as_menu.int_value == 0 and not(self.__menu): 
			scr_w = g.gdk.screen_width()
			scr_h = g.gdk.screen_height()
			width, height = self.get_size()
			# try over main window
			if y - height >= 0: y = y - height
			else:	y = y + h
			if x < 0 : x = 0
			if x + width > scr_w: x = scr_w - width
			if self.show_now(x, y): self.__tip = True
	def show_now_as_menu(self, widget, event):
		if self.__Options.tt_a.int_value == 1 \
			and self.__Options.tt_a_as_menu.int_value == 1 and not(self.__tip):
			x, y, mods = g.gdk.get_default_root_window().get_pointer()
			scr_w = g.gdk.screen_width()
			scr_h = g.gdk.screen_height()
			width, height = self.get_size()
			# try over main window
			if y + 8 - height >= 0:	y = y + 8 - height
			else:	y = y - 8
			if y + height >= scr_h: y = y - scr_h
			x -= 8
			if x < 0 : x = 0
			if x + width > scr_w: x = scr_w - width
			if self.show_now(x, y): self.__menu = True
	def show_now(self, x, y):
		if self.__initialized:
			self.move(x, y)
			self.show_all()
			return True
		else: return False
	def hide_later(self, widget):
		#print "hide now"
		if self.__Options.tt_a.int_value == 1:
			self.__active = False
			tasks.Task(self.wait_and_hide())
	def wait_and_hide(self):
		yield tasks.TimeoutBlocker(0.3);
		if not(self.__active) and self.__initialized:
			#print "hide window"
			self.hide()
			self.__tip = False
			self.__menu = False
			self.__feed = self.__show_list.akt_feed()
			self.refresh()

gobject.signal_new("size_changed_tt_a", ov_aktfeed, gobject.SIGNAL_RUN_LAST,gobject.TYPE_NONE, (gobject.TYPE_PYOBJECT,gobject.TYPE_PYOBJECT,))
